type 'a t = Empty | Node of ('a t * 'a * 'a t);;

let rec size = function
 | Empty -> 0
 | Node (l, _, r) -> size l + size r + 1
;;
let rec height = function
 | Empty -> 0
 | Node (l, _, r) -> max (height l) (height r) + 1
;;
let rec of_list = function
 | [] -> Empty
 | x :: xs -> Node (Empty, x, of_list xs)
;;
let rec make = function
 | [] -> Empty
 | xs ->
  let m = Lst.length xs / 2 in
  let (ys, zs) = Lst.split_at m xs in
  Node (make ys, Lst.hd zs, make (Lst.tl zs))
;;
let rec insert c v = function
 | Empty -> Node (Empty, v, Empty)
 | Node (l, w, r) ->
  if c v w <= 0 then Node (insert c v l, w, r) else Node (l, w, insert c v r)
;;
let search_tree c xs = Lst.fold_left (fun x y -> insert c y x) Empty xs;;
let rec flatten = function
 | Empty -> []
 | Node (l, x, r) -> (flatten l) @ (x :: flatten r)
;;
