type t = char list;;

let of_string s =
 let rec of_string i m s =
  if i = m then [] else String.get s i :: of_string (i +  1) m s
 in of_string 0 (String.length s) s
;;
let to_string xs =
 let rec to_string i s = function
  | [] -> s
  | x :: xs -> String.set s i x; to_string (i + 1) s xs
 in to_string 0 (String.create (Lst.length xs)) xs
;;
let of_int i = of_string (string_of_int i);;
let print s = Format.printf "%s\n" (to_string s);;
let toplevel_printer s =
 Format.printf "\"%s\"" (String.escaped (to_string s))
;;
let join s xs =
 Lst.fold1 (fun xs ys -> xs @ s @ ys) xs
;; 
let right_justify n s = Lst.append (Lst.init ' ' (n - Lst.length s)) s;;
let left_justify n s = Lst.append s (Lst.init ' ' (n - Lst.length s));;
let center n s =
 let d = n - Lst.length s in
 let right = d / 2 in
 let left = d - right in
 Lst.append (Lst.init ' ' left) (Lst.append s (Lst.init ' ' right))
;;
let upper s =
 let is_lower c = 'a' <= c && c <= 'z' in
 let dx = int_of_char 'A' - int_of_char 'a' in
 let to_upper c = char_of_int (int_of_char c + dx) in
 Lst.map (fun c -> if is_lower c then to_upper c else c) s
;;
let rec prefix s t = match (s, t) with
 | ([], _) -> true
 | (_, []) -> false
 | (s :: ss, t :: ts) -> s = t && prefix ss ts
;;
let rec contains s t = match s, t with
 | (_, []) -> true
 | ([], _) -> false
 | (_ :: cs), t -> prefix t s || contains cs t
;;
